(function() {
  var regexp = /\|(\d{1,2})$/;
  var el = $('#attitude');
  var supportClass = 'gb-attitude-like-select';

  //要记录支持状态
  var supportCache = {};
  //获取指定范围的随机数
  function random(min, max) {
    return min + Math.floor(Math.random() * (max - min + 1));
  }

  //编码
  function escape(string) {
    if (!string) {
      return '';
    }
    return ('' + string).replace(/[&<>"']/g, function(match) {
      return {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#x27;',
        '/': '&#x2F;'
      }[match];
    });
  }

  var defauleFashion = {
    '99': 'file:///android_asset/images/face/99.png',
    '98': 'file:///android_asset/images/face/98.png',
    '97': 'file:///android_asset/images/face/97.png',
    '96': 'file:///android_asset/images/face/96.png',
    '95': 'file:///android_asset/images/face/95.png',
    '94': 'file:///android_asset/images/face/94.png',
    '93': 'file:///android_asset/images/face/93.png',
    '92': 'file:///android_asset/images/face/92.png',
    '91': 'file:///android_asset/images/face/91.png',
    '90': 'file:///android_asset/images/face/90.png'
  };

  var defauleClassics = {
    '02': 'file:///android_asset/images/face/02.png',
    '01': 'file:///android_asset/images/face/01.png',
    '03': 'file:///android_asset/images/face/03.png',
    '04': 'file:///android_asset/images/face/04.png',
    '05': 'file:///android_asset/images/face/05.png',
    '06': 'file:///android_asset/images/face/06.png',
    '07': 'file:///android_asset/images/face/07.png',
    '08': 'file:///android_asset/images/face/08.png',
    '09': 'file:///android_asset/images/face/09.png',
    '10': 'file:///android_asset/images/face/10.png',
    '11': 'file:///android_asset/images/face/11.png',
    '12': 'file:///android_asset/images/face/12.png',
    '13': 'file:///android_asset/images/face/13.png',
    '14': 'file:///android_asset/images/face/14.png',
    '15': 'file:///android_asset/images/face/15.png'
  };

  //ui模板
  var tpl = [
    '<div class="gb-attitude-pub-box" data-id="{{id}}">',
    '<a class="gb-attitude-pub-item gb-attitude-pub-item-{{style}}">',
    '<span class="gb-attitude-face-item">',
    '<img src="{{src}}"/>',
    '</span>',
    '<span class="gb-attitude-pub-detail">',
    '<span class="gb-attitude-pub-txt">{{opinion}}</span>',
    '</span>',
    '</a>',
    '<span class="gb-attitude-like {{supportClass}}" data-role="support">{{opinionNum}}人赞同</span>',
    '</div>'
  ].join('');

  //转成视图数据
  function toViewData(data) {
    var tem = [];
    if (!data) {
      return tem;
    }
    data.forEach(function(item, i) {
      var match = regexp.exec(item.opinion);
      var viewItem = {};
      var key;
      var keyNum;
      if (match) {
        key = match[1];
        viewItem.opinion = item.opinion.replace(match[0], '');
      } else {
        key = random(90, 99);
        viewItem.opinion = item.opinion;
      }
      keyNum = parseInt(key, 10);
      if (keyNum >= 40 && keyNum <= 69) {
        key = keyNum + 30 + '';
      }
      viewItem.supportClass = supportCache[item.id] ? supportClass : '';
      viewItem.id = item.id;
      viewItem.opinionNum = item.opinionNum;
      viewItem.style = i > 1 ? 'ex1' : 'ex';
      viewItem.src = defauleFashion[key] || defauleClassics[key] || '';
      tem.push(viewItem);
    });
    return tem;
  }

  function render(item) {
    return tpl.replace(/\{\{(.*?)\}\}/img, function(s, p) {
      return escape(item[p] + '');
    });
  }

  function role(_role, parent) {
    return (parent || el).find('[data-role=' + _role + ']');
  }

  function support(event) {
    var $item = $(this);
    var id = $item.data('id'),
      $support, supportText, num;
    if (!supportCache[id]) {
      $support = role('support', $item);
      supportText = $support.text();
      num = parseInt(supportText, 10) + 1;
      $support.addClass(supportClass);
      $support.text(supportText.replace(/\d+/, num));
      supportCache[id] = true;
      attitude.support(id);
    } else {
      attitude.support();
    }
  }

  //绑定事件
  function bindEvents() {
    el.on('click', '[data-id]', support);
  }

  //更新
  function update(data) {
    var total = data.opinionTotal;
    var viewData = toViewData(data.opinionList);
    var htmlStr = '';
    for (var i = 0; i < viewData.length && i < 4; i++) {
      htmlStr += render(viewData[i]);
    }
    role('total').text(data.praisingTotal);
    role('attitudeList').empty().append(htmlStr);
    if (total < 1) {
      role('emptyTip').show();
    } else {
      role('emptyTip').hide();
      total > 3 ? role('allAttitude').show() : role('allAttitude').hide();
    }
  }
  bindEvents();
  if (window.attitudeData) {
    update(window.attitudeData);
  }
  window.attitudeHandle = update;
})();
